searchNodes=[{"ref":"Agala.html","title":"Agala","type":"module","doc":"Main framework module. Basic Application. Should be started as external application in your mix.exs file in order to use Agala."},{"ref":"Agala.html#execute/2","title":"Agala.execute/2","type":"function","doc":"This method provides functionality to send request and get response to bot responser&#39;s provider. You can use it in order to call method out of request-response cycle. For example - to get additional parameters from provider&#39;s entity. Examples Agala.execute(fn conn -&gt; Users.get(conn, user_ids, fields, name_case) end, bot_params)"},{"ref":"Agala.html#get/2","title":"Agala.get/2","type":"function","doc":"Gets the value, stored under the given key across bot&#39;s supervisor lifetime. Can be usefull to reveal some state across restarting handlers, responsers and receivers."},{"ref":"Agala.html#response_with/1","title":"Agala.response_with/1","type":"function","doc":"Function in the global scope. Starts the navigation process of the response. Calling this function will send the response to nesessery bot across the cluster. Handler&#39;s response is automaticly casted to this function. Params conn - Agala.Conn with populated Agala.Conn.Response."},{"ref":"Agala.html#set/3","title":"Agala.set/3","type":"function","doc":"Sets given value under given key across bot&#39;s supervisor lifetime. Can be usefull to store some state across restarting handlers, responsers and receivers."},{"ref":"Agala.Bot.html","title":"Agala.Bot","type":"module","doc":"This module represents main Bot supervisor. Bot is a complex module, that can retreive information, handle it and send either to recepient or to another Bot module. Defining new Bot requires only name, provider and handler. When the Bot is starting it will automaticly make supervision tree for next modules: Agala.Bot.Receiver - module which gets new data from the recepient defined as a provider Agala.Bot.Handler - module which is handling messages, that are incoming to the bot Agala.Bot.Responser - module, that converts your application responses into form, acceptable by the recepient Agala.Bot.Storage [OPTIONALY] - module with Storage behaviour, that helps with keeping cross-crashing data for providers Starting your bot You can start as many bots as you want. They should be differ from each other only by name. Thus, they can have similar provider, handler and whatever you want. To specify bot instance, use Agala.BotParams - they should be passed as an argument to start new bot. Example # Starting 2 bots with different providers: Supervisor.start_link([ {Agala.Bot, %{name: &quot;telegram&quot;, provider: Agala.Provider.Telegram, handler: ...}}, {Agala.Bot, %{name: &quot;vk&quot;, provider: Agala.Provider.Vk, handler: ...}}, ])"},{"ref":"Agala.Bot.Config.html","title":"Agala.Bot.Config","type":"module","doc":""},{"ref":"Agala.Bot.Config.html#compile_config/3","title":"Agala.Bot.Config.compile_config/3","type":"function","doc":"Retrieves the compile time configuration for the bot."},{"ref":"Agala.Bot.Handler.html","title":"Agala.Bot.Handler","type":"module","doc":"Module, represents the bank which gets messages from poller and then syncronosly proceeds them"},{"ref":"Agala.Bot.Handler.html#handle/2","title":"Agala.Bot.Handler.handle/2","type":"function","doc":"This method is called in order to pass messages from responser to handler. This method is asyncronous, so you will not be blocked when calling it. All incoming messages will be put in handler&#39;s message box and the will be proceeded one by one. This method will wrap message in Agala.Conn struct, and then proceed it with Agala.Chain You probably should not use this method in bot developing, but you can understand how the flow is working if you need to create your own provider."},{"ref":"Agala.Bot.Plug.html","title":"Agala.Bot.Plug","type":"module","doc":"This module can be used to build Bots to retrieve updates from third-parties as webhooks."},{"ref":"Agala.Bot.Receiver.html","title":"Agala.Bot.Receiver","type":"behaviour","doc":"You can use this behaviour for implementing your own provider. This receiver has simple generic idea: In loop, it&#39;s geting new messages via get_updates/2 callback Then, these messages are sent into handler one after one. So, you actually can use Agala.Bot.Receiver, and implement only one method - get_updates/2, which will get new messages. This callback will be called by framework itself, but in order to push messages into Agala.Bot.Handler you should call notify_with/1 lambda, that will come as first argument to your get_updates/2 function. Example # Simple random numbers generator defmodule Random.Receiver do use Agala.Bot.Receiver def get_updates(notify_with, _bot_params) do notify_with(:rand.uniform) end end"},{"ref":"Agala.Bot.Receiver.html#c:get_updates/2","title":"Agala.Bot.Receiver.get_updates/2","type":"callback","doc":"TODO: Docs"},{"ref":"Agala.Bot.Receiver.html#t:message/0","title":"Agala.Bot.Receiver.message/0","type":"type","doc":""},{"ref":"Agala.Bot.Responser.html","title":"Agala.Bot.Responser","type":"behaviour","doc":"Behaviour, represents the bank which gets Agala.Conn from Chain and then syncronosly proceeds them to response"},{"ref":"Agala.Bot.Responser.html#response/1","title":"Agala.Bot.Responser.response/1","type":"function","doc":"This method can be used to send Agala.Conn, prepared by Agala.Chain, to appropriate provider responer, which implements Agala.Reponser behaviour."},{"ref":"Agala.Bot.Responser.html#c:response/2","title":"Agala.Bot.Responser.response/2","type":"callback","doc":""},{"ref":"Agala.Bot.Storage.html","title":"Agala.Bot.Storage","type":"behaviour","doc":"Behavior for modules that represent permanent storage system for Agala bot. The problem Sometimes, some bot parts can shut down because of internal errors. It has no sense to handle this errors in letitcrash approach. Thus, bot should have the place to store some data that should not be lost during restarts. Of cource, developer should implement his own storage for business logic, but providers can use this storage to save internal data. Implementation Each Agala.Storage should mandatory implement two methods: set/3 and get/2. This methods are used to keep and retrieve data. If this storage is fundamental, it&#39;s lifecycle will be unlinked from Agala.Bot instance. But, you can implement optional child_spec/1 method. In this case, the Agala.Storage module will be started inside Agala.Bot supervision tree."},{"ref":"Agala.Bot.Storage.html#c:child_spec/1","title":"Agala.Bot.Storage.child_spec/1","type":"callback","doc":""},{"ref":"Agala.Bot.Storage.html#c:get/2","title":"Agala.Bot.Storage.get/2","type":"callback","doc":""},{"ref":"Agala.Bot.Storage.html#c:set/3","title":"Agala.Bot.Storage.set/3","type":"callback","doc":""},{"ref":"Agala.Bot.Storage.Local.html","title":"Agala.Bot.Storage.Local","type":"module","doc":"Basic Agala.Storage implimentation. The data is stored in Agent, that is started under Agala.Bot supervisor tree."},{"ref":"Agala.Bot.Storage.Local.html#get/2","title":"Agala.Bot.Storage.Local.get/2","type":"function","doc":"Callback implementation for Agala.Bot.Storage.get/2."},{"ref":"Agala.Bot.Storage.Local.html#set/3","title":"Agala.Bot.Storage.Local.set/3","type":"function","doc":"Callback implementation for Agala.Bot.Storage.set/3."},{"ref":"Agala.BotParams.html","title":"Agala.BotParams","type":"module","doc":"This module specified generic system for configuration all the variety of Agala bots. It helps to keep types of the params in consistence. Every Agala bot requires some common params, and also requires some specific params for only that bot type. Both of them can be specified in BotParams structure. BotParams will be piped throw all the processes of your bot&#39;s lifecycle, untill the message will be finaly sent to the external environment. So, the params are: name - name for specific bot. You can read about names and why they are so important. provider - the name of the provider which will be used in this bot. You can read about them here. handler - handler&#39;s pipline, which will work with incomming messages and do all the business logic. Thees modules you will create during your application development. You can read about handlers pipline here. provider_params - params, that are needed only for specified provider. Agala framework does not define any structure for these params, you can find it in your providers documentation. private - sepcial place to put some additional information. These params can be precalculated by the internal processes of initiation for your provider, or to cache some data. In common situations you should not use it at all, until you are developing your own provider. common - almost the same as private params, but they are the same across all possible providers. Read about them in the section below. Common params. Common params works the same as private params - store information for providers. But, they are common for each and every provider, and can touch not only Agala.Provider specific layer, but also Agala layer. You can use them inside your providers to control application flow: restart: true will force Agala.Bot.Receiver process to restart in next cycle."},{"ref":"Agala.BotParams.html#t:t/0","title":"Agala.BotParams.t/0","type":"type","doc":"Type, representing Agala.BotParams struct."},{"ref":"Agala.Chain.html","title":"Agala.Chain","type":"behaviour","doc":"The Chain specification. There are two kind of Chains: function Chains and module Chains. Function Chains A function Chain is any function that receives a connection and a set of options and returns a connection. Its type signature must be: (Agala.Conn.t, Agala.Chain.opts) :: Agala.Conn.t Module Chains A module Chain is an extension of the function Chain. It is a module that must export: a call/2 function with the signature defined above an init/1 function which takes a set of options and initializes it. The result returned by init/1 is passed as second argument to call/2. Note that init/1 may be called during compilation and as such it must not return pids, ports or values that are not specific to the runtime. The API expected by a module Chain is defined as a behaviour by the Agala.Chain module (this module). Examples Here&#39;s an example of a function Chain: #TODO Here&#39;s an example of a module Chain: #TODO The Chain pipeline The Agala.Chain.Builder module provides conveniences for building Chain pipelines."},{"ref":"Agala.Chain.html#c:call/2","title":"Agala.Chain.call/2","type":"callback","doc":""},{"ref":"Agala.Chain.html#c:init/1","title":"Agala.Chain.init/1","type":"callback","doc":""},{"ref":"Agala.Chain.html#t:opts/0","title":"Agala.Chain.opts/0","type":"type","doc":""},{"ref":"Agala.Chain.Builder.html","title":"Agala.Chain.Builder","type":"module","doc":""},{"ref":"Agala.Chain.Builder.html#chain/2","title":"Agala.Chain.Builder.chain/2","type":"macro","doc":"A macro that stores a new chain. opts will be passed unchanged to the new chain. This macro doesn&#39;t add any guards when adding the new chain to the pipeline; for more information about adding chains with guards see compile/1. Examples chain Agala.Chain.Logger # chain module chain :foo, some_options: true # chain function"},{"ref":"Agala.Chain.Builder.html#compile/3","title":"Agala.Chain.Builder.compile/3","type":"function","doc":"Compiles a chain pipeline. Each element of the chain pipeline (according to the type signature of this function) has the form: {chain_name, options, guards} Note that this function expects a reversed pipeline (with the last chain that has to be called coming first in the pipeline). The function returns a tuple with the first element being a quoted reference to the connection and the second element being the compiled quoted pipeline. Examples Agala.Chain.Builder.compile(env, [ {Agala.Chain.Logger, [], true}, # no guards, as added by the Agala.Chain.Builder.chain/2 macro {Agala.Chain.Head, [], quote(do: a when is_binary(a))} ], [])"},{"ref":"Agala.Chain.Builder.html#t:chain/0","title":"Agala.Chain.Builder.chain/0","type":"type","doc":""},{"ref":"Agala.Chain.Loopback.html","title":"Agala.Chain.Loopback","type":"module","doc":"Loopback automaticly sends response back to the bot, which got the request You can use this Chain in pipeline in order to simplify resolving name of the bot, that should response with your connections. Example: defmodule SimpleHandler chain Agala.Chain.Loopback chain :handle def handle(conn, _opts) do # Here, responser already the same, as receiver assert conn.responser_name == conn.request_bot_params.name end end"},{"ref":"Agala.Conn.html","title":"Agala.Conn","type":"module","doc":"The Agala connection. This module defines a Agala.Conn struct. This struct contains both request and response data. Request fields These fields contain request information: request - request data structure. It&#39;s internal structure depends on provider type."},{"ref":"Agala.Conn.html#assign/3","title":"Agala.Conn.assign/3","type":"function","doc":"Assigns a value to a key in the connection Examples iex&gt; conn.assigns[:hello] nil iex&gt; conn = assign(conn, :hello, :world) iex&gt; conn.assigns[:hello] :world"},{"ref":"Agala.Conn.html#async_assign/3","title":"Agala.Conn.async_assign/3","type":"function","doc":"Starts a task to assign a value to a key in the connection. await_assign/2 can be used to wait for the async task to complete and retrieve the resulting value. Behind the scenes, it uses Task.async/1. Examples iex&gt; conn.assigns[:hello] nil iex&gt; conn = async_assign(conn, :hello, fn -&gt; :world end) iex&gt; conn.assigns[:hello] %Task{...}"},{"ref":"Agala.Conn.html#await_assign/3","title":"Agala.Conn.await_assign/3","type":"function","doc":"Awaits the completion of an async assign. Returns a connection with the value resulting from the async assignment placed under key in the :assigns field. Behind the scenes, it uses Task.await/2. Examples iex&gt; conn.assigns[:hello] nil iex&gt; conn = async_assign(conn, :hello, fn -&gt; :world end) iex&gt; conn = await_assign(conn, :hello) # blocks until `conn.assigns[:hello]` is available iex&gt; conn.assigns[:hello] :world"},{"ref":"Agala.Conn.html#halt/1","title":"Agala.Conn.halt/1","type":"function","doc":"Halts the Agala.Chain pipeline by preventing further chains downstream from being invoked. See the docs for Agala.Chain.Builder for more information on halting a Chain pipeline."},{"ref":"Agala.Conn.html#put_private/3","title":"Agala.Conn.put_private/3","type":"function","doc":"Assigns a new private key and value in the connection. This storage is meant to be used by libraries and frameworks to avoid writing to the user storage (the :assigns field). It is recommended for libraries/frameworks to prefix the keys with the library name. For example, if some plug needs to store a :hello key, it should do so as :plug_hello: iex&gt; conn.private[:plug_hello] nil iex&gt; conn = put_private(conn, :plug_hello, :world) iex&gt; conn.private[:plug_hello] :world"},{"ref":"Agala.Conn.html#send_to/2","title":"Agala.Conn.send_to/2","type":"function","doc":"Specifies the name for the bot, which will send the response back to side APIs."},{"ref":"Agala.Conn.html#with_fallback/2","title":"Agala.Conn.with_fallback/2","type":"function","doc":"Specifies the lambda function that will be called after the result of provider&#39;s respponse to the bot&#39;s response will appear. The lambda shuld have only one parameter - Agala.Conn.t for current connection. It&#39;ll have request with request to bot, response with response from bot, and fallback with response sending results."},{"ref":"Agala.Conn.html#t:t/0","title":"Agala.Conn.t/0","type":"type","doc":""},{"ref":"Agala.Conn.Multi.html","title":"Agala.Conn.Multi","type":"module","doc":"This module represents a set of macros, that can be used to performed multiple operation inside one Agala.Conn instance. The problem Sometimes you need to perform several actions inside one batch. For example send multiple messages, or delete previous message and send new one. You can do this inside handler inside handling one Agala.Conn."},{"ref":"Agala.Conn.Multi.html#add/1","title":"Agala.Conn.Multi.add/1","type":"macro","doc":""},{"ref":"Agala.Conn.Multi.html#multi/1","title":"Agala.Conn.Multi.multi/1","type":"macro","doc":""},{"ref":"Agala.Provider.html","title":"Agala.Provider","type":"behaviour","doc":"Behaviour that defines root structure for Agala provider"},{"ref":"Agala.Provider.html#c:get_receiver/0","title":"Agala.Provider.get_receiver/0","type":"callback","doc":"This function defines name for Agala.Reciever module for specific provider. This adds some portion of flexibility for provider creators - the are not forced to follow any naming convention. Examples iex&gt; Agala.Provider.Vk.get_receiver Agala.Provider.Vk.Receiver iex&gt; Agala.Provider.Telegram.get_receiver Agala.Provider.Telegram.Receiver"},{"ref":"Agala.Provider.html#c:get_responser/0","title":"Agala.Provider.get_responser/0","type":"callback","doc":"This function defines name for Agala.Responser module for specific provider. This adds some portion of flexibility for provider creators - the are not forced to follow any naming convention. Examples iex&gt; Agala.Provider.Vk.get_responser Agala.Provider.Vk.Responser iex&gt; Agala.Provider.Telegram.get_responser Agala.Provider.Telegram.Responser"},{"ref":"Agala.Util.html","title":"Agala.Util","type":"module","doc":""},{"ref":"Agala.Util.html#behaviours_list/1","title":"Agala.Util.behaviours_list/1","type":"function","doc":"Method is used to retrieve module&#39;s behaviour list. Example: defmodule FooBar do @behaviour Foo @Behaviour Bar end iex&gt; Agala.Util.behaviours_list(FooBar) [Foo, Bar]"},{"ref":"getting-started.html","title":"Getting Started","type":"extras","doc":""},{"ref":"getting-started.html#getting-started","title":"Getting Started - Getting started","type":"extras","doc":""},{"ref":"usage.html","title":"Usage","type":"extras","doc":""},{"ref":"usage.html#getting-started","title":"Usage - Getting started","type":"extras","doc":""}]